{% macro list_item(endpoint, name, icon) %}
    <a class="mdc-list-item"{% if endpoint %} href="{{ url_for(endpoint) }}"{% endif %} data-name="{{ name }}">

            {% if icon.startswith('http') %}
                <img class="mdc-list-item__graphic svg" src="{{ icon }}">
            {% elif icon.startswith('<svg') %}
                {{ icon|safe }}
            {% else %}
                <i class="material-icons-outlined mdc-list-item__graphic">{{ icon }}</i>
            {% endif %}
        <span class="mdc-list-item__text">{{ name }}</span>
    </a>
{% endmacro %}

{% macro text_input(field) %}
    <div class="mdc-text-field">
        {{ field(id=field.name, class='mdc-text-field__input', autocomplete='off')|safe }}
        <label class="mdc-floating-label" for="{{ field.name }}">{{ field.label }}</label>
        <div class="mdc-line-ripple"></div>
    </div>
    <p class="mdc-typography--caption description">{{ field.description }}</p>
{% endmacro %}

{% macro textarea_input(field) %}
    <div class="mdc-text-field mdc-text-field--textarea">
        {{ field(id=field.name, class='mdc-text-field__input', autocomplete='off')|safe }}
        <div class="mdc-notched-outline">
            <div class="mdc-notched-outline__leading"></div>
            <div class="mdc-notched-outline__notch">
                <label for="{{ field.name }}" class="mdc-floating-label">{{ field.label }}</label>
            </div>
            <div class="mdc-notched-outline__trailing"></div>
        </div>
    </div>
    <p class="mdc-typography--caption description">{{ field.description }}</p>
{% endmacro %}

{% macro file_input(field) %}
    <div class="mdc-text-field mdc-text-field--with-trailing-icon">
        {{ field(hidden='', id=field.name, class='file-input')|safe }}

        <input class="mdc-text-field__input file-text-input"
               id="t-{{ field.name }}"
               data-input-id="{{ field.name }}"
               autocomplete="off"
        {% if field.flags.required %}required{% endif %}
        >
        <label class="mdc-floating-label" for="t-{{ field.name }}">{{ field.label }}</label>
        <i class="material-icons-outlined mdc-text-field__icon">attach_file</i>
        <div class="mdc-line-ripple"></div>
    </div>
    <p class="mdc-typography--caption description">{{ field.description }}</p>
{% endmacro %}

{% macro select_input(field) %}
    <div class="mdc-select">
        <i class="mdc-select__dropdown-icon"></i>
        <select class="mdc-select__native-control" id="{{ field.name }}" name="{{ field.name }}">
            <option value="" disabled selected></option>
            {% for val, label in field.choices %}
                <option value="{{ val }}" {% if val == field.data %}selected{% endif %}>
                    {{ label }}
                </option>
            {% endfor %}
        </select>
        <label class="mdc-floating-label" for="{{ field.name }}">{{ field.label }}</label>
        <div class="mdc-line-ripple"></div>
    </div>
    <p class="mdc-typography--caption description">{{ field.description }}</p>
{% endmacro %}

{% macro input(field, class) %}
    <div class="input-wrapper {{ class }}">
        {% if field.type in ['StringField', 'PasswordField', 'IntegerField'] %}
            {{ text_input(field) }}
        {% elif field.type == 'SelectField' %}
            {{ select_input(field) }}
        {% elif field.type == 'TextAreaField' %}
            {{ textarea_input(field) }}
        {% elif field.type == 'FileField' or field.type == 'MultipleFileField' %}
            {{ file_input(field) }}
        {% endif %}
        {% for error in field.errors %}
            <p class="mdc-typography--caption error-msg">{{ error }}</p>
        {% endfor %}
    </div>
{% endmacro %}

{% macro submit_button(text) %}
    <div>
        <button type="submit" class="mdc-button mdc-button--unelevated">{{ text }}</button>
    </div>
{% endmacro %}

{% macro icon_button(text, icon, class, url) %}
    {% if url %}
        <a class="mdc-button {{ class }}" href="{{ url }}">
            <i class="material-icons-outlined mdc-button__icon">{{ icon }}</i>
            <span class="mdc-button__label">{{ text }}</span>
        </a>
    {% else %}
        <button class="mdc-button {{ class }}">
            <i class="material-icons-outlined mdc-button__icon">{{ icon }}</i>
            <span class="mdc-button__label">{{ text }}</span>
        </button>
    {% endif %}
{% endmacro %}

{% macro post_button(text, icon, class, url) %}
    <form action="{{ url }}" method="post" class="post-button-form">
        <button class="mdc-button {{ class }}">
            <i class="material-icons-outlined mdc-button__icon">{{ icon }}</i>
            <span class="mdc-button__label">{{ text }}</span>
        </button>
    </form>
{% endmacro %}

{% macro add_button(text, endpoint) %}
    {{ icon_button(text, 'add', 'add-button', url_for(endpoint)) }}
{% endmacro %}

{% macro table_no_button() %}
    <span style="line-height: 35px;">&nbsp;</span>
{% endmacro %}

{% macro checkbox(label, class, field_class, checked=False) %}
    <div class="input-wrapper">
        <div class="mdc-form-field checkbox-form-field {{ class }}" data-field-class="{{ field_class }}">
            <div class="mdc-checkbox">
                <input type="checkbox"
                       class="mdc-checkbox__native-control"
                       id="checkbox-1"
                       {% if checked %}checked{% endif %}/>
                <div class="mdc-checkbox__background">
                    <svg class="mdc-checkbox__checkmark"
                         viewBox="0 0 24 24">
                        <path class="mdc-checkbox__checkmark-path"
                              fill="none"
                              d="M1.73,12.91 8.1,19.28 22.79,4.59"></path>
                    </svg>
                    <div class="mdc-checkbox__mixedmark"></div>
                </div>
            </div>
            <label for="checkbox-1">{{ label }}</label>
        </div>
    </div>
{% endmacro %}

{% macro dialog(title, text, id='main', class='', actions=None) %}
    <div class="mdc-dialog {{ class }}" role="alertdialog">
        <div class="mdc-dialog__container">
            <div class="mdc-dialog__surface">
                <h2 class="mdc-dialog__title" id="{{ id }}-dialog-title">{{ title }}</h2>
                <div class="mdc-dialog__content" id="{{ id }}-dialog-content">
                    {{ text }}
                </div>
                <footer class="mdc-dialog__actions">
                    {% if actions is none %}
                        <button type="button" class="mdc-button mdc-dialog__button" data-mdc-dialog-action="ok">
                            <span class="mdc-button__label">OK</span>
                        </button>
                    {% else %}
                        <p>IMPLEMENT ME</p>
                    {% endif %}
                </footer>
            </div>
        </div>
        <div class="mdc-dialog__scrim"></div>
    </div>
{% endmacro %}

{% macro flashed_dialog(category, title) %}
    {% with errors = get_flashed_messages(category_filter=[category]) %}
        {% for msg in errors %}
            {{ dialog(title, msg, class='error-dialog') }}
        {% endfor %}
    {% endwith %}
{% endmacro %}

{% macro non_field_err(form) %}
    {% if form.non_field_error %}
        <p class="mdc-typography--caption form-error">{{ form.non_field_error }}</p>
    {% endif %}
{% endmacro %}

{% macro icon(name, class='') %}
    <i class="material-icons-outlined mdc-list-item__graphic {{ class }}">{{ name }}</i>
{% endmacro %}

{% macro entity_info_button(title=None, entity=None, class='') %}
    {{ icon('info', class + ' icon pointer show-entity-info-button') }}
    <span class="entity-title hidden">
        {% if title is none %}
            {% if entity.obj %}
                {{ entity.obj.metadata.name }}
            {% else %}
                {{ entity.metadata.name }}
            {% endif %}
        {% else %}
            {{ title }}
        {% endif %}
    </span>
    <span class="entity-obj hidden">
        {% if entity.obj %}
            {{ entity.obj|tojson(indent=4) }}
        {% else %}
            {{ entity|tojson(indent=4) }}
        {% endif %}
    </span>
{% endmacro %}
